# SHIFT6mq

## Custom ROM Setup 
> Allgemeine Übersicht

1. fastboot/adb an den Start bringen
2. Geräteverbindung checken (ggf. Bootloader entsperren)
3. Recovery, Magisk, ROM laden
4. Recovery flashen (z.B. TWRP via fastboot Menü, Tastenkombination)
5. Magisk, ROM als Zip oä drauf bekommen (ggf. via SD Card)
6. Bootmenü starten (Tastenkombination)
7. Magisk & ROM installieren (Magisk zum rooten nutzen, ggf. nachträglich)
8. have fun

## Reference Links

- https://wiki.lineageos.org/adb_fastboot_guide.html
- https://box4gsm.blogspot.com/2019/11/how-to-install-adb-and-fastboot-on-arch.html
- https://doc.e.foundation/devices/axolotl/install
- https://doc.e.foundation/build-status
- https://magisk.me/
- https://github.com/topjohnwu/Magisk


**extra:**
> - https://lineageosroms.com/axolotl/
> - https://skyhawkrecovery.github.io/Devices.html (TWPR Theme + Features)
> - https://twrp.me/




## Steps to take

### 0. Gerät vorbereiten

Zurücksetzen und OHNE Internet Verbindung und Google Account an den Start bringen!

### 1. fastboot & adb an den Start bringen

**Manjaro Cinnamon - Arch Linux Setup**

![Video](https://www.youtube.com/watch?v=CWWf1M25jYs)

`sudo pacman -S android-tools`

**Ubuntu based Systems**

https://www.digitbin.com/install-use-adb-fastboot-linux/

### 2. Geräteverbindung aufbauen

Laut [Anleitung](https://doc.e.foundation/devices/axolotl/install) via Tastenkombination

`Volume Up + Power` 

Startet den `FASTBOOT` Download Modus 

(Screenshot)

Via Terminal überprüfen mit 

`fastboot devices`

(Screenshot)

> Falls Ausfall/zu lange nicht verwendet: Nochmal Tastenkombination bis das Gerät erneut in den Modus startet!

Wenn der Fasstboot Check erfolgreich war, den Bootloader checken mit der Auswahl `Reboot to bootloader` und dort steht dann der lock/unlock status vom bootloader. 

Falls Bootloader zu entsperren ist mit 

`fastboot flashing unlock` 

freigeben. 

> ggf. kommt folgende Fehlermeldung:
>
>```
>FAILED (remote: 'Flashing Unlock is not allowed')
>fastboot: error: Command failed
>```
> in diesem Fall "OEM unlock" via erweiterter Geräteeinstellungen im OS notwendig, wenn keine Ausgabe möglich

Erfolgreich wenn folgende Meldung erfolgt:

```
OKAY [  0.036s]
Finished. Total time: 0.037s

```
> :warning: Das Bootloader entsperren resettet und rebootet das Gerät!

Danach noch die Auswahl "UNLOCK THE BOOTLOADER" bestätigen. 

> :exclamation: im Anschluss ist dadurch ein erneutes Freigeben vom USB-debugging notwendig via Geräte Settings (alle anderen Setup-Einstellungen überspringen, wird ohnehin überschrieben)


> **Note:** der bootloader bleibt entsperrt, soweit das die Dokumentation ausweist! überprüfen?


### 3. Recovery, Magisk, ROM laden
> kann parallel zu den anderen Schritten zuvor geschehen

Aktuell ist von eOS nur [Android T(13)](https://images.ecloud.global/dev/axolotl/) als "Test" Version verfügbar, sollte aber stabil laufen. Bekannte [Issues](https://gitlab.e.foundation/groups/e/-/issues/?label_name%5B%5D=axolotl&label_name%5B%5D=type%3A%3ABug) sind hier verlinkt.

**Software bereithalten**

1. [eOS, recovery](https://doc.e.foundation/devices/axolotl)
2. [Magisk](https://magisk.me/zip/) (apk to zip benennen)
3. Microg (bei eOS inkl.)


Nach dem freigeben vom adb (USB-Debugging) Modus (siehe Hinweis oben) wieder in den fastboot/bootloader Modus wechseln und Verbindung prüfen mit `fastboot devices`. 

> Falls das Telefon noch gebootet ist, einfach via `adb reboot bootloader` die Abkürzung nehmen und ddamit auch die USB Verbindung überprüfen.

Terminal in dem Verzeichnis des Recovery Files öffnen oder dort hin navigieren mit `cd ...`.

Anschließend das Custom Recovery (e.g. eOS oder TWRP) flashen mit: 

`fastboot flash recovery <recoveryfilename>.img`

> e.g. `fastboot flash recovery recovery-e-1.20-t-20240221382228-dev-axolotl.img`

